<?php

namespace Drupal\entity_extender_node\Plugin\EntityTypeExtender;

use Drupal\entity_extender\Plugin\EntityTypeExtender\EntityHandlerDefinitionAccess;
use Drupal\entity_extender\Plugin\EntityTypeExtender\EntityHandlerDefinitionStorage;
use Drupal\entity_extender\Plugin\EntityTypeExtender\EntityHandlerDefinitionView;
use Drupal\entity_extender\Plugin\EntityTypeExtender\EntityTypeExtender;
use Drupal\node\NodeAccessControlHandler;
use Drupal\node\NodeStorage;
use Drupal\node\NodeViewBuilder;

/**
 * Defines the extended entity type.
 *
 * @EntityTypeExtenderPlugin("node")
 */
class NodeEntityTypeExtender extends EntityTypeExtender {

  /**
   * {@inheritdoc}
   */
  public function getHandlers(): array {
    return [
      new EntityHandlerDefinitionAccess(NodeAccessControlHandler::class, NodeHandlerAccess::class),
      new EntityHandlerDefinitionStorage(NodeStorage::class, NodeHandlerStorage::class),
      new EntityHandlerDefinitionView(NodeViewBuilder::class, NodeHandlerView::class),
    ];
  }

}
