<?php

namespace Drupal\entity_extender_user\Plugin\EntityTypeExtender;

use Drupal\Core\Entity\EntityViewBuilder;
use Drupal\entity_extender\Plugin\EntityTypeExtender\EntityHandlerDefinitionAccess;
use Drupal\entity_extender\Plugin\EntityTypeExtender\EntityHandlerDefinitionStorage;
use Drupal\entity_extender\Plugin\EntityTypeExtender\EntityHandlerDefinitionView;
use Drupal\entity_extender\Plugin\EntityTypeExtender\EntityTypeExtender;
use Drupal\user\UserAccessControlHandler;
use Drupal\user\UserStorage;

/**
 * Defines the extended entity type.
 *
 * @EntityTypeExtenderPlugin("user")
 */
class UserEntityTypeExtender extends EntityTypeExtender {

  /**
   * {@inheritdoc}
   */
  public function getHandlers(): array {
    return [
      new EntityHandlerDefinitionAccess(UserAccessControlHandler::class, UserHandlerAccess::class),
      new EntityHandlerDefinitionStorage(UserStorage::class, UserHandlerStorage::class),
      new EntityHandlerDefinitionView(EntityViewBuilder::class, UserHandlerView::class),
    ];
  }

}
