<?php

namespace Drupal\entity_extender;

use Drupal\Component\Plugin\PluginManagerInterface;

/**
 * Describes the extender's entity type manager.
 */
interface EntityTypeExtenderManagerInterface extends PluginManagerInterface {

  /**
   * Extends entity types.
   *
   * @param \Drupal\Core\Entity\EntityTypeInterface[] $entity_types
   *   The associative array of entity type definitions.
   *
   * @see \entity_extender_entity_type_alter()
   */
  public function extend(array $entity_types): void;

}
